package com.fs.his.service;

import java.util.List;

import com.fs.common.core.domain.R;
import com.fs.his.domain.FsCoupon;
import com.fs.his.param.FsCouponListUParam;
import com.fs.his.param.FsCouponParam;
import com.fs.his.param.FsCouponReceiveParam;
import com.fs.his.vo.FsCouponAllListVO;
import com.fs.his.vo.FsCouponListUVO;
import com.fs.his.vo.FsCouponListVO;

/**
 * 优惠券Service接口
 *
 * @author fs
 * @date 2023-09-04
 */
public interface IFsCouponService
{
    /**
     * 查询优惠券
     *
     * @param couponId 优惠券主键
     * @return 优惠券
     */
    public FsCoupon selectFsCouponByCouponId(Long couponId);

    /**
     * 查询优惠券列表
     *
     * @param fsCoupon 优惠券
     * @return 优惠券集合
     */
    public List<FsCoupon> selectFsCouponList(FsCoupon fsCoupon);

    /**
     * 新增优惠券
     *
     * @param fsCoupon 优惠券
     * @return 结果
     */
    public int insertFsCoupon(FsCoupon fsCoupon);

    /**
     * 修改优惠券
     *
     * @param fsCoupon 优惠券
     * @return 结果
     */
    public int updateFsCoupon(FsCoupon fsCoupon);

    /**
     * 批量删除优惠券
     *
     * @param couponIds 需要删除的优惠券主键集合
     * @return 结果
     */
    public int deleteFsCouponByCouponIds(Long[] couponIds);

    /**
     * 删除优惠券信息
     *
     * @param couponId 优惠券主键
     * @return 结果
     */
    public int deleteFsCouponByCouponId(Long couponId);

    List<FsCouponListVO> selectFsCouponListVO(FsCouponParam fsCoupon);


    List<FsCouponAllListVO> selectFsCouponListAll();

    List<FsCouponListUVO> selectFsCouponListUVO(FsCouponListUParam param);

    R receive(FsCouponReceiveParam param);
}
